libcaca importers/exporters from/to various
libcaca attribute definitions » libcaca basic functions » libcaca canvas drawing » libcaca dirty rectangle manipulation » libcaca canvas transformation » libcaca attribute conversions » libcaca character set conversions » libcaca primitives drawing » libcaca canvas frame handling » libcaca bitmap dithering » libcaca character font handling » libcaca bitmap font handling » libcaca FIGfont handling » libcaca file IO

## Modules

| libcaca display functions

## Functions

__extern ssize_t | caca_import_canvas_from_memory (caca_canvas_t *, void const *, size_t, char const *)
| Import a memory buffer into a canvas. More...
__extern ssize_t | caca_import_canvas_from_file (caca_canvas_t *, char const *, char const *)
| Import a file into a canvas. More...
__extern ssize_t | caca_import_area_from_memory (caca_canvas_t *, int, int, void const *, size_t, char const *)
| Import a memory buffer into a canvas area. More...
__extern ssize_t | caca_import_area_from_file (caca_canvas_t *, int, int, char const *, char const *)
| Import a file into a canvas area. More...
__extern char const *const * | caca_get_import_list (void)
| Get available import formats. More...
__extern void * | caca_export_canvas_to_memory (caca_canvas_t const *, char const *, size_t *)
| Export a canvas into a foreign format. More...
__extern void * | caca_export_area_to_memory (caca_canvas_t const *, int, int, int, int, char const *, size_t *)
| Export a canvas portion into a foreign format. More...
__extern char const *const * | caca_get_export_list (void)
| Get available export formats. More...

## Detailed Description

formats

These functions import various file formats into a new canvas, or export the current canvas to various text formats.

## Function Documentation

## caca_import_canvas_from_memory()

__extern ssize_t caca_import_canvas_from_memory | ( | caca_canvas_t * | cv,
|  | void const * | data,
|  | size_t | len,
|  | char const * | format
| ) |  |

Import a memory buffer into the given libcaca canvas's current frame. The current frame is resized accordingly and its contents are replaced with the imported data.

Valid values for `format` are:

- `""`: attempt to autodetect the file format.
- `"caca"`: import native libcaca files.
- `"text"`: import ASCII text files.
- `"ansi"`: import ANSI files.
- `"utf8"`: import UTF-8 files with ANSI colour codes.
- `"bin"`: import BIN files.

The number of bytes read is returned. If the file format is valid, but not enough data was available, 0 is returned.

If an error occurs, -1 is returned and errno is set accordingly:

- `ENOMEM` Not enough memory to allocate canvas.
- `EOVERFLOW` Importing data caused a value overflow.
- `EINVAL` Invalid format requested.

Parameters

  cv | A libcaca canvas in which to import the file.
  data | A memory area containing the data to be loaded into the canvas.
  len | The size in bytes of the memory area.
  format | A string describing the input format.

Returns
  The number of bytes read, or 0 if there was not enough data, or -1 if an error occurred.

Referenced by caca_import_area_from_memory(), and caca_import_canvas_from_file().

## caca_import_canvas_from_file()

__extern ssize_t caca_import_canvas_from_file | ( | caca_canvas_t * | cv,
|  | char const * | filename,
|  | char const * | format
| ) |  |

Import a file into the given libcaca canvas's current frame. The current frame is resized accordingly and its contents are replaced with the imported data.

Valid values for `format` are:

- `""`: attempt to autodetect the file format.
- `"caca"`: import native libcaca files.
- `"text"`: import ASCII text files.
- `"ansi"`: import ANSI files.
- `"utf8"`: import UTF-8 files with ANSI colour codes.
- `"bin"`: import BIN files.

The number of bytes read is returned. If the file format is valid, but not enough data was available, 0 is returned.

If an error occurs, -1 is returned and errno is set accordingly:

- `ENOSYS` File access is not implemented on this system.
- `ENOMEM` Not enough memory to allocate canvas.
- `EINVAL` Invalid format requested. caca_import_file() may also fail and set errno for any of the errors specified for the routine fopen().

Parameters

  cv | A libcaca canvas in which to import the file.
  filename | The name of the file to load.
  format | A string describing the input format.

Returns
  The number of bytes read, or 0 if there was not enough data, or -1 if an error occurred.

References caca_file_close(), caca_file_eof(), caca_file_open(), caca_file_read(), and caca_import_canvas_from_memory().

Referenced by caca_import_area_from_file().

## caca_import_area_from_memory()

__extern ssize_t caca_import_area_from_memory | ( | caca_canvas_t * | cv,
|  | int | x,
|  | int | y,
|  | void const * | data,
|  | size_t | len,
|  | char const * | format
| ) |  |

Import a memory buffer into the given libcaca canvas's current frame, at the specified position. For more information, see caca_import_canvas_from_memory().

If an error occurs, -1 is returned and errno is set accordingly:

- `EINVAL` Unsupported format requested or invalid coordinates.
- `ENOMEM` Not enough memory to allocate canvas.

Parameters

  cv | A libcaca canvas in which to import the file.
  x | The leftmost coordinate of the area to import to.
  y | The topmost coordinate of the area to import to.
  data | A memory area containing the data to be loaded into the canvas.
  len | The size in bytes of the memory area.
  format | A string describing the input format.

Returns
  The number of bytes read, or 0 if there was not enough data, or -1 if an error occurred.

References caca_blit(), caca_create_canvas(), caca_free_canvas(), and caca_import_canvas_from_memory().

## caca_import_area_from_file()

__extern ssize_t caca_import_area_from_file | ( | caca_canvas_t * | cv,
|  | int | x,
|  | int | y,
|  | char const * | filename,
|  | char const * | format
| ) |  |

Import a file into the given libcaca canvas's current frame, at the specified position. For more information, see caca_import_canvas_from_file().

If an error occurs, -1 is returned and errno is set accordingly:

- `ENOSYS` File access is not implemented on this system.
- `ENOMEM` Not enough memory to allocate canvas.
- `EINVAL` Unsupported format requested or invalid coordinates. caca_import_file() may also fail and set errno for any of the errors specified for the routine fopen().

Parameters

  cv | A libcaca canvas in which to import the file.
  x | The leftmost coordinate of the area to import to.
  y | The topmost coordinate of the area to import to.
  filename | The name of the file to load.
  format | A string describing the input format.

Returns
  The number of bytes read, or 0 if there was not enough data, or -1 if an error occurred.

References caca_blit(), caca_create_canvas(), caca_free_canvas(), and caca_import_canvas_from_file().

## caca_get_import_list()

__extern char const* const* caca_get_import_list | ( | void |  | ) |

Return a list of available import formats. The list is a NULL-terminated array of strings, interleaving a string containing the internal value for the import format, to be used with caca_import_canvas(), and a string containing the natural language description for that import format.

This function never fails.

Returns
  An array of strings.

## caca_export_canvas_to_memory()

__extern void* caca_export_canvas_to_memory | ( | caca_canvas_t const * | cv,
|  | char const * | format,
|  | size_t * | bytes
| ) |  |

This function exports a libcaca canvas into various foreign formats such as ANSI art, HTML, IRC colours, etc. The returned pointer should be passed to free() to release the allocated storage when it is no longer needed.

Valid values for `format` are:

- `"caca"`: export native libcaca files.
- `"ansi"`: export ANSI art (CP437 charset with ANSI colour codes).
- `"html"`: export an HTML page with CSS information.
- `"html3"`: export an HTML table that should be compatible with most navigators, including textmode ones.
- `"irc"`: export UTF-8 text with mIRC colour codes.
- `"ps"`: export a PostScript document.
- `"svg"`: export an SVG vector image.
- `"tga"`: export a TGA image.
- `"troff"`: export a troff source.

If an error occurs, NULL is returned and errno is set accordingly:

- `EINVAL` Unsupported format requested.
- `ENOMEM` Not enough memory to allocate output buffer.

Parameters

  cv | A libcaca canvas
  format | A string describing the requested output format.
  bytes | A pointer to a size_t where the number of allocated bytes will be written.

Returns
  A pointer to the exported memory area, or NULL in case of error.

Referenced by caca_export_area_to_memory().

## caca_export_area_to_memory()

__extern void* caca_export_area_to_memory | ( | caca_canvas_t const * | cv,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | char const * | format,
|  | size_t * | bytes
| ) |  |

This function exports a portion of a libcaca canvas into various formats. For more information, see caca_export_canvas_to_memory().

If an error occurs, NULL is returned and errno is set accordingly:

- `EINVAL` Unsupported format requested or invalid coordinates.
- `ENOMEM` Not enough memory to allocate output buffer.

Parameters

  cv | A libcaca canvas
  x | The leftmost coordinate of the area to export.
  y | The topmost coordinate of the area to export.
  w | The width of the area to export.
  h | The height of the area to export.
  format | A string describing the requested output format.
  bytes | A pointer to a size_t where the number of allocated bytes will be written.

Returns
  A pointer to the exported memory area, or NULL in case of error.

References caca_blit(), caca_create_canvas(), caca_export_canvas_to_memory(), and caca_free_canvas().

## caca_get_export_list()

__extern char const* const* caca_get_export_list | ( | void |  | ) |

Return a list of available export formats. The list is a NULL-terminated array of strings, interleaving a string containing the internal value for the export format, to be used with caca_export_memory(), and a string containing the natural language description for that export format.

This function never fails.

Returns
  An array of strings.